function [out,saterr,qerr] = q2(in,fbits,sat1wrap0);
% function out = q2(in,fbits,sat1wrap0);
% quantization with saturation or wrapping
% default to wrapping

if ~exist('sat1wrap0','var'), sat1wrap0 = 0; end;

I = find(abs(in)>1);
if sat1wrap0 ~=0 % saturate
    sg = sign(in);
    out = in;
    out(I) = sg(I); % replace all the values above 1 with the correct sign
else % wrap
    out = in;
    out(I) = mod(in(I)+1,2)-1; % mod does a floating point computation that 
                               % slightly changes all values, so only change
                               % the ones that need it
end
saterr = out-in; % compute error due to saturation
% quantize
qin = out;
out = round(out*2^fbits);
out = out/2^fbits;
qerr = out-qin; % compute error due to quantization