%scalingovr.m
% scaling and overflow

% Copyright 2011
% Wayne T. Padgett
% Last Modified -

%
% Most of this code is user interface, the actual signals part is pretty
% short
%
%% SECTION: INITIALIZATION
%
clear all;  % cleans up first
close all;

[x,fs] = wavread('the pipe began to leak 2.wav');
x = 0.99*x+x.^2*0.01*pi; % create a version with unquantized content 

wdl_list = [16, 11, 10, 7, 6];

sat1wrap0 = 0;
fbits = wdl_list(1);
[out,saterr,qerr] = q2(x,fbits,sat1wrap0);

h = msgbox('Playing Original Unquantized','Info');
player = audioplayer(x,fs,16);
playblocking(player);
close(h)

h = msgbox('Playing Quantized','Info');
player = audioplayer(out,fs,16);
playblocking(player);
close(h)

figure(1)
nn = 1:length(x);
subplot(311)
plot(nn,saterr)
legend('saterr')
subplot(312)
plot(nn,qerr)
legend('qerr')
subplot(313)
plot(nn,saterr+qerr,nn,out-x)
legend('sum','toterr')

sigpwr = sum(x.^2)/length(x);
satpwr = sum(saterr.^2)/length(x);
qpwr = sum(qerr.^2)/length(x);
errpwr = sum((out-x).^2)/length(x);
SNRdB = 10*log10(sigpwr/errpwr);
SNRsat = 10*log10(sigpwr/satpwr);
SNRq = 10*log10(sigpwr/qpwr);

